﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Excel = Microsoft.Office.Interop.Excel;

using System.Reflection;
using System.IO;

namespace LoadAssemblyExample
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("13C97C58-A853-4A1C-8FA6-DA09946C5D91"), ProgId("LoadAssemblyExample.AddinModule")]
    public partial class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance 
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }

        private void adxRibbonButton1_OnClick(object sender, IRibbonControl control, bool pressed) {

            string location = Assembly.GetExecutingAssembly().CodeBase;
            string fullPath = new Uri(location).LocalPath; // path including the dll
            string directoryPath = Path.GetDirectoryName(fullPath); // directory path
            string assemblyToLoad = ""; 
            if (IntPtr.Size == 4) //x86
                assemblyToLoad = Path.Combine(directoryPath, "TestAssembly.dll");
            else // x64
                assemblyToLoad = Path.Combine(directoryPath, "TestAssembly64.dll");

            Assembly assembly = Assembly.LoadFile(assemblyToLoad);
            Type type = assembly.GetType("TestAssembly.TestClass");
            var obj = Activator.CreateInstance(type);

            type.InvokeMember("TestMethod", BindingFlags.InvokeMethod | BindingFlags.Public | BindingFlags.Instance, null, obj, new object[] { });


            //TestAssembly.TestClass testClass = new TestAssembly.TestClass();
            //testClass.TestMethod();
        }

    }
}

